; PEACE BE WITH YOU 2OSC (2015) for realtime Csound6 - by Arthur B. Hunkins
; Requires Android OS 4.4.2 or higher, and Csound6.apk built on Csound6.05+
;   Also requires TouchOSC app:
;    https://play.google.com/store/apps/details?id=net.hexler.touchosc_a
; Run both Csound6 and TouchOSC on same Android device
; Open Peace2OSC.touchosc in TouchOSC and this file in Csound6
; In Peace2OSC layout (Settings), set OSC Host to 127.0.0.1,
;   outgoing Port to 8000 and incoming to 9000 (requires no internet connection)
; Note: Be sure to open the touchosc layout before starting Csound.
; Set all touchosc sliders to 0, Start Csound6, then perform in TouchOSC. 
;   Make all button selections before raising one of the amp sliders (1, 4, 7 or 10).
;   Raising one of these four sliders actually begins the performance.
;   To change a button selection after performance has begun, Csound must be
;   stopped, and restarted once sliders have been reset to 0. 
;   In case of audio glitches, reduce the value of sr (Sample Rate, see below)
;    progressively to 32000, 22050, 11025 or 8000 until glitching disappears.

<CsoundSynthesizer>
<CsOptions>

-odac -m0d --expression-opt -b512 -B2048

</CsOptions>
<CsInstruments>

sr      = 44100 ; Sample Rate
ksmps   = 100
nchnls  = 2

gichan  OSCinit 8000

        seed 0

        instr 1

gkmod   init     121
gkpan   init     0
kflag   init     1
kflag2  init     1
kmod    init     0
kans    OSClisten gichan, "/1/butt1", "f", kmod
kmoda   trigger  kmod, .5, 0
        if kmoda == 1 then
gkmod	= 121
        endif
kmod2   init     0
kans    OSClisten gichan, "/1/butt2", "f", kmod2
kmod2a  trigger  kmod2, .5, 0
        if kmod2a == 1 then
gkmod	= 140
        endif
kmod3   init     0
kans    OSClisten gichan, "/1/butt3", "f", kmod3
kmod3a  trigger  kmod3, .5, 0
        if kmod3a == 1 then
gkmod	= 148
        endif
kmod4   init     0
kans    OSClisten gichan, "/1/butt4", "f", kmod4
kmod4a  trigger  kmod4, .5, 0
        if kmod4a == 1 then
gkmod	= 174
        endif
kmod5   init     0
kans    OSClisten gichan, "/1/butt5", "f", kmod5
kmod5a  trigger  kmod5, .5, 0
        if kmod5a == 1 then
gkmod	= 184
        endif
kpan2   init     0
kans    OSClisten gichan, "/1/butt7", "f", kpan2
kpan2a  trigger  kpan2, .5, 0
        if kpan2a == 1 then
gkpan   = 1
Span    strcpyk  "controller"
        endif
kpan3   init     0
kans    OSClisten gichan, "/1/butt8", "f", kpan3
kpan3a  trigger  kpan3, .5, 0
        if kpan3a == 1 then
gkpan   = 2
Span    strcpyk  "static rand"
        endif
kpan4   init     0
kans    OSClisten gichan, "/1/butt9", "f", kpan4
kpan4a  trigger  kpan4, .5, 0
        if kpan4a == 1 then
gkpan   = 3
Span    strcpyk  "varying rand"
        endif
kpan    init     0
kans    OSClisten gichan, "/1/butt6", "f", kpan
kpana   trigger  kpan, .5, 0
        if kpana == 1 then
gkpan   = 0
Span    strcpyk  "fixed"
        endif
kchange changed  gkmod, gkpan
        if kchange == 1 then
Spreset sprintfk "ModFreq=%d  PanMode=%s", gkmod, Span
        OSCsend  kflag, "127.0.0.1", 9000, "/1/label", "s", Spreset
kflag   = (kflag == 1? 2: 1)
        endif
kcps    init     0
kans    OSClisten gichan, "/1/slider2", "f", kcps
gkcps   = 1 + (kcps * 2.8)
kcps2   init     0
kans    OSClisten gichan, "/1/slider5", "f", kcps2
gkcps2  = 1 + (kcps2 * 2.8)
kcps3   init     0
kans    OSClisten gichan, "/1/slider8", "f", kcps3
gkcps3  = 1 + (kcps3 * 2.8)
kcps4   init     0
kans    OSClisten gichan, "/1/slide11", "f", kcps4
gkcps4  = 1 + (kcps4 * 2.8)
knewcps changed  gkcps, gkcps2, gkcps3, gkcps4
        if knewcps == 1 then
Svar    sprintfk "%1.2f  %1.2f  %1.2f  %1.2f", gkcps, gkcps2, gkcps3, gkcps4
        OSCsend  kflag2, "127.0.0.1", 9000, "/1/label", "s", Svar
kflag2  = (kflag2 == 1? 2: 1)
        endif
kndx    init     0
kans    OSClisten gichan, "/1/slider3", "f", kndx
gkndx   = kndx
kndx2   init     0
kans    OSClisten gichan, "/1/slider6", "f", kndx2
gkndx2  = kndx2
kndx3   init     0
kans    OSClisten gichan, "/1/slider9", "f", kndx3
gkndx3  = kndx3
kndx4   init     0
kans    OSClisten gichan, "/1/slider12", "f", kndx4
gkndx4  = kndx4
kpan1   init     0
kans    OSClisten gichan, "/1/slider13", "f", kpan1
kpan1a  = kpan1
kpan2   init     0
kans    OSClisten gichan, "/1/slider14", "f", kpan2
kpan2a  = kpan2
kpan3   init     0
kans    OSClisten gichan, "/1/slider15", "f", kpan3
kpan3a  = kpan3
kpan4   init     0
kans    OSClisten gichan, "/1/slider16", "f", kpan4
kpan4a  = kpan4
kamp    init     0
kans    OSClisten gichan, "/1/slider1", "f", kamp
kampa   = kamp
kamp2   init     0
kans    OSClisten gichan, "/1/slider4", "f", kamp2
kamp2a  = kamp2
kamp3   init     0
kans    OSClisten gichan, "/1/slider7", "f", kamp3
kamp3a  = kamp3
kamp4   init     0
kans    OSClisten gichan, "/1/slider10", "f", kamp4
kamp4a  = kamp4
kstart  trigger  kampa + kamp2a + kamp3a + kamp4a, 0, 0
        if kstart > 0 then
        event    "i", 2, 0, 3600, gkmod, gkpan, kpan1a
        event    "i", 3, 0, 3600, gkmod, gkpan, kpan2a
        event    "i", 4, 0, 3600, gkmod, gkpan, kpan3a
        event    "i", 5, 0, 3600, gkmod, gkpan, kpan4a
        turnoff
        endif
        
        endin
        
        instr 2
        
kpan    init     0
kamp    init     0
kpan1   init     p6
        if p5 == 1 then
kans    OSClisten gichan, "/1/slider13", "f", kpan1
kpan2   = kpan1
        endif
kans    OSClisten gichan, "/1/slider1", "f", kamp
kamp2   port     kamp * 10000, .05
krand   rspline  .6, 1, .3, .8
kfreq	rspline .5, 2.5, 2, 2
kcps    init     0
kans    OSClisten gichan, "/1/slider2", "f", kcps
        if kans == 1 then
gkcps   = 1 + (kcps * 2.8)
        endif
kndx    init     0
kans    OSClisten gichan, "/1/slider3", "f", kndx
        if kans == 1 then
gkndx   = kndx
        endif
kndx1   port     gkndx * 8, .05
kndx2   jitter   .5, .8, 1
a1	foscil   kamp2 * krand, gkcps, 400 + (kfreq/gkcps), p4, kndx1 * (abs(kndx2) + 1), 1
a2      atonex   a1, 250 * gkcps, 6
        if p5 > 0 then
        if p5 == 3 then
kpan    rspline -.2, .3, .25, .4
kpan    = (kpan < 0? 0: kpan)
        else
ktrig   trigger  kamp2, 10, 0
        if ktrig > 0 then
        if p5 == 1 then
kpan    = kpan2        
        else
kpan    rnd31    .5, .8
kpan    = kpan + .5
        endif
        endif
        endif
        endif
a3, a4  pan2     a2, kpan
        outs     a3, a4

        endin

        instr 3

kpan    init     .33
kamp    init     0
kpan1   init     p6
        if p5 == 1 then
kans    OSClisten gichan, "/1/slider14", "f", kpan1
kpan2   = kpan1
        endif
kans    OSClisten gichan, "/1/slider4", "f", kamp
kamp2   port     kamp * 10000, .05
krand   rspline  .6, 1, .3, .8
kfreq	rspline  .5, 2.5, 2, 2
kcps    init     0
kans    OSClisten gichan, "/1/slider5", "f", kcps
        if kans == 1 then
gkcps2  = 1 + (kcps * 2.8)
        endif
kndx    init     0
kans    OSClisten gichan, "/1/slider6", "f", kndx
        if kans == 1 then
gkndx2  = kndx
        endif
kndx1   port     gkndx2 * 8, .05
kndx2   jitter   .5, .8, 1
kadd	jspline  .15, .7, 1
a1	foscil   kamp2 * krand, gkcps2, 400 + (kfreq/gkcps2), p4 + kadd, kndx1 * (abs(kndx2) + 1), 1
a2      atonex   a1, 250 * gkcps2, 6
        if p5 > 0 then
        if p5 == 3 then
kpan    rspline .1, .6, .25, .4
        else
ktrig   trigger  kamp2, 10, 0
        if ktrig > 0 then
        if p5 == 1 then
kpan    = kpan2        
        else
kpan    rnd31    .5, .8
kpan    = kpan + .5
        endif
        endif
        endif
        endif
a3, a4  pan2     a2, kpan
        outs     a3, a4

        endin

        instr 4

kpan    init     .67
kamp    init     0
kpan1   init     p6
        if p5 == 1 then
kans    OSClisten gichan, "/1/slider15", "f", kpan1
kpan2   = kpan1
        endif
kans    OSClisten gichan, "/1/slider7", "f", kamp
kamp2   port     kamp * 10000, .05
krand   rspline  .6, 1, .3, .8
kfreq	rspline  .5, 2.5, 2, 2
kcps    init     0
kans    OSClisten gichan, "/1/slider8", "f", kcps
        if kans == 1 then
gkcps3  = 1 + (kcps * 2.8)
        endif
kndx    init     0
kans    OSClisten gichan, "/1/slider9", "f", kndx
        if kans == 1 then
gkndx3  = kndx
        endif
kndx1   port     gkndx3 * 8, .05
kndx2   jitter   .5, .8, 1
kadd	jspline  .15, .7, 1
a1	foscil   kamp2 * krand, gkcps3, 400 + (kfreq/gkcps3), p4 + kadd, kndx1 * (abs(kndx2) + 1), 1
a2      atonex   a1, 250 * gkcps3, 6
        if p5 > 0 then
        if p5 == 3 then
kpan    rspline .4, .9, .25, .4
        else
ktrig   trigger  kamp2, 10, 0
        if ktrig > 0 then
        if p5 == 1 then
kpan    = kpan2        
        else
kpan    rnd31    .5, .8
kpan    = kpan + .5
        endif
        endif
        endif
        endif
a3, a4  pan2     a2, kpan
        outs     a3, a4

        endin

        instr 5

kpan    init     1
kflag   init     1
kamp    init     0
kpan1   init     p6
        if p5 == 1 then
kans    OSClisten gichan, "/1/slider16", "f", kpan1
kpan2   = kpan1
        endif
kans    OSClisten gichan, "/1/slider10", "f", kamp
kamp2   port     kamp * 10000, .05
krand   rspline  .6, 1, .3, .8
kfreq	rspline  .5, 2.5, 2, 2
kcps    init     0
kans    OSClisten gichan, "/1/slider11", "f", kcps
        if kans == 1 then
gkcps4  = 1 + (kcps * 2.8)
        endif
kchange changed  gkcps, gkcps2, gkcps3, gkcps4
        if kchange == 1 then
Svar    sprintfk "%1.2f  %1.2f  %1.2f  %1.2f", gkcps, gkcps2, gkcps3, gkcps4
        OSCsend  kflag, "127.0.0.1", 9000, "/1/label", "s", Svar
kflag   = (kflag == 1? 2: 1)
        endif
kndx    init     0
kans    OSClisten gichan, "/1/slider12", "f", kndx
        if kans == 1 then
gkndx4  = kndx
        endif
kndx1   port     gkndx4 * 8, .05
kndx2   jitter   .5, .8, 1
kadd	jspline  .15, .7, 1
a1	foscil   kamp2 * krand, gkcps4, 400 + (kfreq/gkcps4), p4 + kadd, kndx1 * (abs(kndx2) + 1), 1
a2      atonex   a1, 250 * gkcps4, 6
        if p5 > 0 then
        if p5 == 3 then
kpan    rspline .7, 1.2, .25, .4
kpan    = (kpan > 1? 1: kpan)
        else
ktrig   trigger  kamp2, 10, 0
        if ktrig > 0 then
        if p5 == 1 then
kpan    = kpan2        
        else
kpan    rnd31    .5, .8
kpan    = kpan + .5
        endif
        endif
        endif
        endif
a3, a4  pan2     a2, kpan
        outs     a3, a4
            
        endin

</CsInstruments>
<CsScore>

f 1 0 16384 10 1 .0005 .001
i 1 0 3600

e

</CsScore>
</CsoundSynthesizer>