; PEACE BE WITH YOU (2015) for realtime Csound6 - by Arthur B. Hunkins
; Requires Android OS 2.3 or higher, and Csound6a.apk or Csound6c.apk
;   Downloadable from http://www.arthunkins.com/Android_Csound_Apps.htm
;   Run Csound6a or Csound6c, and Browse to (Open) this file
;   In case of audio glitches, reduce the value of sr (Sample Rate, see below)
;    progressively to 32000, 22050, 11025 or 8000 until glitching disappears.

<CsoundSynthesizer>
<CsOptions>

-odac -m0d --expression-opt -b512 -B2048

</CsOptions>
<CsInstruments>

sr      = 44100 ; Sample Rate
ksmps   = 100
nchnls  = 2

gkamp   chnexport "slider1", 1
gkamp2  chnexport "slider4", 1
gkamp3  chnexport "slider7", 1
gkcps   chnexport "slider2", 1
gkcps2  chnexport "slider5", 1
gkcps3  chnexport "slider8", 1

        seed 0

        instr 1

gkmod   init 121
gkpan   init 0
kflag   init 1
ktime   times
        if ktime = 2 then
        printks "ModFreq=121  PanMode=fixed\\n", 0
        endif
kmod	chnget "butt1"
kmoda   trigger  kmod, .5, 0
        if kmoda == 1 then
gkmod	= 121
        endif
kmod2	chnget "butt2"
kmod2a  trigger  kmod2, .5, 0
        if kmod2a == 1 then
gkmod	= 140
        endif
kmod3	chnget "butt3"
kmod3a  trigger  kmod3, .5, 0
        if kmod3a == 1 then
gkmod	= 148
        endif
kmod4	chnget "butt4"
kmod4a  trigger  kmod4, .5, 0
        if kmod4a == 1 then
gkmod	= 174
        endif
kmod5	chnget "butt5"
kmod5a  trigger  kmod5, .5, 0
        if kmod5a == 1 then
gkmod	= 184
        endif
kpan2   chnget "butt7"
kpan2a  trigger  kpan2, .5, 0
        if kpan2a == 1 then
gkpan   = 1
Span    strcpyk "controller"
        endif
kpan3   chnget "butt8"
kpan3a  trigger  kpan3, .5, 0
        if kpan3a == 1 then
gkpan   = 2
Span    strcpyk "static rand"
        endif
kpan4   chnget "butt9"
kpan4a  trigger  kpan4, .5, 0
        if kpan4a == 1 then
gkpan   = 3
Span    strcpyk "varying rand"
        endif
kpan1   chnget "butt6"
kpan1a  trigger  kpan1, .5, 0
        if kpan1a == 1 then
gkpan   = 0
Span    strcpyk "fixed"
        endif
kchange changed gkmod, gkpan
        if kchange == 1 then
Spreset sprintfk "ModFreq=%d  PanMode=%s", gkmod, Span
        puts Spreset, kflag
kflag   = (kflag == 1? 2: 1)
        endif
gkcpsa  = 1 + (gkcps * 2.8)
gkcps2a = 1 + (gkcps2 * 2.8)
gkcps3a = 1 + (gkcps3 * 2.8)
knewcps changed gkcps, gkcps2, gkcps3
        if knewcps == 1 then
        printks "    %1.2f   %1.2f   %1.2f\\n", 0, gkcpsa, gkcps2a, gkcps3a
        endif
kstart  trigger gkamp + gkamp2 + gkamp3, 0, 0
        if kstart > 0 then
        event "i", 2, 0, 3600, gkmod, gkpan
        event "i", 3, 0, 3600, gkmod, gkpan
        event "i", 4, 0, 3600, gkmod, gkpan
        turnoff
        endif
        
        endin
        
        instr 2
        
kpan    init 0
kamp    port gkamp * 10000, .05
krand   rspline .6, 1, .3, .8
kfreq	rspline .5, 2.5, 2, 2
gkcpsa  = 1 + (gkcps * 2.8)
kndx    chnget "slider3"
kndx    port kndx * 8, .05
kndx2   jitter .5, .8, 1
a1	foscil kamp * krand, gkcpsa, 400 + (kfreq/gkcpsa), p4, kndx * (abs(kndx2) + 1), 1
a2      atonex a1, 250 * gkcpsa, 6
        if p5 > 0 then
        if p5 == 3 then
kpan    rspline -.1, .5, .25, .4
kpan    = (kpan < 0? 0: kpan)
        else
ktrig   trigger kamp, 1, 0
        if ktrig > 0 then
        if p5 == 1 then
kpan    chnget "slider10"
        else
kpan    rnd31 .5, .8
kpan    = kpan + .5
        endif
        endif
        endif
        endif
a3, a4  pan2 a2, kpan
        outs a3, a4

        endin

        instr 3

kpan    init .5
kamp    port gkamp2 * 10000, .05
krand   rspline .6, 1, .3, .8
kfreq	rspline .5, 2.5, 2, 2
gkcps2a = 1 + (gkcps2 * 2.8)
kndx    chnget "slider6"
kndx    port kndx * 8, .05
kndx2   jitter .5, .8, 1
kadd	jspline .15, .7, 1
a1	foscil kamp * krand, gkcps2a, 400 + (kfreq/gkcps2a), p4 + kadd, kndx * (abs(kndx2) + 1), 1
a2      atonex a1, 250 * gkcps2a, 6
        if p5 > 0 then
        if p5 == 3 then
kpan    rspline .25, .75, .25, .4
        else
ktrig   trigger kamp, 1, 0
        if ktrig > 0 then
        if p5 == 1 then
kpan    chnget "slider11"
        else
kpan    rnd31 .5, .8
kpan    = kpan + .5
        endif
        endif
        endif
        endif
a3, a4  pan2 a2, kpan
        outs a3, a4

        endin

        instr 4

kpan    init 1
kamp    port gkamp3 * 10000, .05
krand   rspline .6, 1, .3, .8
kfreq	rspline .5, 2.5, 2, 2
gkcps3a = 1 + (gkcps3 * 2.8)
kchange changed gkcps, gkcps2, gkcps3
        if kchange == 1 then
        printks "    %1.2f   %1.2f   %1.2f\\n", 0, gkcpsa, gkcps2a, gkcps3a
        endif
kndx    chnget "slider9"
kndx    port kndx * 8, .05
kndx2   jitter .5, .8, 1
kadd	jspline .15, .7, 1
a1	foscil kamp * krand, gkcps3a, 400 + (kfreq/gkcps3a), p4 + kadd, kndx * (abs(kndx2) + 1), 1
a2      atonex a1, 250 * gkcps3a, 6
        if p5 > 0 then
        if p5 == 3 then
kpan    rspline .5, 1.1, .25, .4
kpan    = (kpan > 1? 1: kpan)
        else
ktrig   trigger kamp, 1, 0
        if ktrig > 0 then
        if p5 == 1 then
kpan    chnget "slider12"
        else
kpan    rnd31 .5, .8
kpan    = kpan + .5
        endif
        endif
        endif
        endif
a3, a4  pan2 a2, kpan
        outs a3, a4
            
        endin

</CsInstruments>
<CsScore>

f 1 0 16384 10 1 .0005 .001
i 1 0 3600

e

</CsScore>
</CsoundSynthesizer>