powershape.csd
Written by Iain McCurdy, 2009
adapted by Zappfinger for websockets 2015

<CsoundSynthesizer>

<CsOptions>
-odac -dm0 -iadc
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
ksmps 		= 	8	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)
0dbfs		=	1	;MAXIMUM AMPLITUDE


instr	1
    ; we are getting these values form our client (sliders)
    kShapeAmount    chnget "shape"
    kOutputGain     chnget "gain"
    kpregain        chnget "pregain"
    kpostgain       chnget "postgain"
    kshape1         chnget "shape1"
    kshape2         chnget "shape2"
    kinput          chnget "input"
    if kinput==2  then
	    ain		diskin2		"808loopMono.wav", 1, 0, 1
	else
	    ain     inch 1
	endif
	ifullscale	=	1	;DEFINE FULLSCALE AMPLITUDE VALUE
	aout 		powershape 	ain, kShapeAmount , ifullscale	;CREATE POWERSHAPED SIGNAL
	adistort	distort1	ain, kpregain, kpostgain, kshape1, kshape2, 1
	outs		aout * kOutputGain/2 + adistort/2, aout * kOutputGain + adistort/2	;SEND AUDIO TO OUTPUTS AND RESCALE USING kOutputGain SLIDER VARIABLE
    kVol        rms aout * kOutputGain
    ; we are reading this in our client (VU meter) via periodic polling in the server
    chnset      kVol, "volume"
endin
		
</CsInstruments>

<CsScore>
i 1 0 3600	;DUMMY SCORE EVENT. ALLOWS REAL-TIME PERFORMANCE FOR 1 HOUR.
</CsScore>

</CsoundSynthesizer>