;######   #####  #######                                           
;#     # #     # #        ####   ####   ####  #    # #    # #####  
;#     # #       #       #    # #      #    # #    # ##   # #    # 
;######  #       #####   #       ####  #    # #    # # #  # #    # 
;#     # #       #       #           # #    # #    # #  # # #    # 
;#     # #     # #       #    # #    # #    # #    # #   ## #    # 
;######   #####  #        ####   ####   ####   ####  #    # #####  
;Olivier Baudouin, 2015

<CsoundSynthesizer>

<CsOptions>
-@ CSOUNDRC
</CsOptions>


<CsInstruments>

sr = 44100
ksmps = 10
nchnls = 2

;-----------------;
;       BCF       ;
;-----------------;
;========
;OPTIONAL
#define BCFPATH #<mypath>/BCF/# ;don't forget the last slashes
#define BCFBACKUPPATH #<mypath>/backup/# ;Windows: backslashes
#define BCF2 ##
;#define BCF3 ##
;#define BCF4 ##
;========
;REQUIRED
#define BCFREALDUR #600# ;macro or init variable. Must match with score duration.
#include "BCF.inc"
;-----------------;
gSinstr1 init "BCFtemplate.orc"

    instr Recompile

iMode init 1
iRelease init 0.1

iIns1 nstrnum "Instr1"
turnoff2 iIns1, iMode, iRelease
;iIns2...

iRes compileorc gSinstr1
schedule "Instr1", 0, $BCFREALDUR
if (iRes == 0) then
  Smess2 = "OK!\\n\\n"
else
  Smess2 = "FAILED!\\n\\n"
endif

Smess strcat "\\n\\nRECOMPILATION ", Smess2
prints Smess

turnoff

    endin


    instr Main

iBCFmode init 1
iBCF1chn init 1
iBCF2chn init 2
iBCF1dispTime init 1
iBCF2dispTime init 0
iBCFctrlChn init iBCF1chn

gkf1, kf2, kf3, kf4, kf5, kf6, kf7, \\
ke1, ke2, ke3, ke4, ke5, ke6, ke7, \\
kb1, kb2, kb3, kb4, kb5, kb6, kb7, \\
kRecompile_, kCurTime_ BCF1 iBCF1chn, iBCFmode, $BCFREALDUR, iBCFctrlChn, iBCF1dispTime

gkf1b, kf2b, kf3b, kf4b, kf5b, kf6b, kf7b, \\
ke1b, ke2b, ke3b, ke4b, ke5b, ke6b, ke7b, \\
kb1b, kb2b, kb3b, kb4b, kb5b, kb6b, kb7b, \\
kRecompile, kCurTime BCF2 iBCF2chn, iBCFmode, $BCFREALDUR, iBCFctrlChn, iBCF2dispTime

iRes compileorc gSinstr1
schedule "Instr1", 0, $BCFREALDUR
;Instr2...

schedkwhen kRecompile, 0.1, 1, "Recompile", 0, 1
       
    endin

</CsInstruments>
<CsScore>

#define DUR #600#
i "Main" 0 $DUR.

</CsScore>
</CsoundSynthesizer>
